# SkDisplay  

SkDisplay is a Skript addon that adds visual features. SkDisplay is not dependent on any plugin other than Skript.


Version | 1.7 | 1.8 | 1.9 | 1.10 | 1.11 | 1.12 | 1.13
------------ | ------------- | ------------ | ------------- | ------------ | ------------ | ------------ | ------------
Compatible | ❌ | ✅ | ✅ | ✅ | ✅ | ✅ | ❌ |


## Todo

* Effects
    - [x] Display Scoreboards
    - [ ] Show Title / Subtitle
    - [ ] Show ActionBar
    - [ ] Show BossBar
    - [x] Item Cooldown Effect
    - [x] Change Skin
    - [x] Spawn a corpse
    - [ ] Ghost Player
 
 * Conditions
    - [ ] Has Scoreboards
    - [ ] Has BossBar
    - [ ] Has Skin
    - [ ] Has Corpse
   

## Soon

* Nametags
* Scope Section for Scoreboard

## Finished
### Gadgets
<details>
    <summary>EffAddHoverCooldown</summary>
    <h5>Not available in 1.8. This feature was added with Minecraft 1.9</h5>
    
    Description: Applies the cooldown effect of enderpearl
    Type: Effect
    Version: From 1.9
    
</details>

### Skin
<details>
    <summary>EffSetPlayerSkin</summary>
    <h5>Available from 1.8 to 1.12.2</h5>  
        
    Description: Modifies the player skin
    Type: Effect
    Version: From 1.8
    
</details>
<details>
    <summary>EffResetPlayerSkin</summary>
    <h5>Available from 1.8 to 1.12.2</h5>  
        
    Description: Reset the player skin
    Type: Effect
    Version: From 1.8
    
</details>

### Scoreboard
<details>
    <summary>EffCreateScoreboard</summary>
    <h5>Available from 1.8 to 1.12.2</h5>  
        
    Description: Create a scoreboard for the player
    Type: Effect
    Version: From 1.8
    
</details>
<details>
    <summary>EffAddLineScoreboard</summary>
    <h5>Available from 1.8 to 1.12.2</h5>  
        
    Description: Adds lines to the player's scoreboard
    Type: Effect
    Version: From 1.8
    
</details>
<details>
    <summary>EffSetTitleScoreboard</summary>
    <h5>Available from 1.8 to 1.12.2</h5>  
        
    Description: Modifies the scoreboard title
    Type: Effect
    Version: From 1.8
    
</details>
<details>
    <summary>EffRemoveLineScoreboard</summary>
    <h5>Available from 1.8 to 1.12.2</h5>  
        
    Description: Remove lines from the player's scoreboard
    Type: Effect
    Version: From 1.8
    
</details>
<details>
    <summary>EffDestroyScoreboad</summary>
    <h5>Available from 1.8 to 1.12.2</h5>  
        
    Description: Destroys the player's scoreboard
    Type: Effect
    Version: From 1.8
    
</details>

## Functional syntaxes

```vb
create scoreboard named "Hello" for player
set scoreboard line 1 to "Edit line" for player
destroy scoreboard of player
set scoreboard title to "World" for player
remove scoreboard line 2 for player
set player's skin to "Notch"
reset player's skin
add cooldown to player's tool for 2 seconds for player
```

